#include <bits/stdc++.h>

using namespace std;

#define nl '\n'

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n,q;
        cin>>n>>q;


    vector<int> a(n);
    int bits[n][32];
        for(int i =0;i<n;i++){
            cin>>a[i];
        }
       int psum[n+1][32];
       for(int i =0;i<=n;i++){
        for(int j =0;j<32;j++)psum[i][j]=0;
       }

        for(int i =0;i<n;i++){

            for(int j =0;j<32;j++){
                int k = 1<<j;
                if(!(a[i]&k))bits[i][j]=0;
                else bits[i][j]=1;
            }


        }


        for(int i =1;i<=n;i++){
            for(int j = 0;j<32;j++){
                psum[i][j]=psum[i-1][j]+bits[i-1][j];
            }
        }




        vector<int> ans(q);

        for(int i =0;i<q;i++){
            int l,r;
            cin>>l>>r;
            l-=1;r-=1;
            int p = 31;
            int s = 0;
            while(s==0){
                for(int i =l;i<=r;i++){
                    s+=bits[i][p];
                }
                p--;
            }
            ans[i]=s;
        }
        for(int i =0;i<q;i++)cout<<ans[i]<<nl;
        //cout<<ans[q-1];


    return 0;
}